image: docker:latest
# ref https://docs.gitlab.com/ee/user/packages/container_registry/#build-and-push-images-using-gitlab-cicd

stages:
  - build
  - push

services:
  - name: docker:dind
    alias: localhost # https://stackoverflow.com/questions/57059851/gitlab-ci-gives-curl-7-failed-to-connect-to-localhost-port-8090-connection-r

variables:
  CONTAINER_TAG_FOR_TESTS: deepcube/UoA-Sextant:test-image
  CONTAINER_TEST_IMAGE: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG
  CONTAINER_RELEASE_IMAGE: $CI_REGISTRY_IMAGE:latest
  CONTAINER_RELEASE_TAGGED_IMAGE: $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG

# these variable are automatically filled by gitlab
before_script:
  # docker login asks for the password to be passed through stdin for security
  # we use $CI_JOB_TOKEN here which is a special token provided by GitLab
  - echo -n $CI_REGISTRY_PASSWORD | docker login -u "$CI_REGISTRY_USER" --password-stdin $CI_REGISTRY

# build the image and push it on gitlab registry
build:
  stage: build
  script:
    - docker build --pull -t "$CONTAINER_TEST_IMAGE" .
    - docker push "$CONTAINER_TEST_IMAGE"

# push "latest" image to the registry
build-latest:
  stage: push
  only:
    - main # latest from main only
    - master
  script:
    - docker pull $CONTAINER_TEST_IMAGE
    - docker tag $CONTAINER_TEST_IMAGE $CONTAINER_RELEASE_IMAGE
    - docker push $CONTAINER_RELEASE_IMAGE

# push "tagged" image to the registry
build-release:
  stage: push
  # only start a release on tags of master (not other branches)
  only:
    - tags # latest from master only
  except:
    - branches
  script:
    - docker pull $CONTAINER_TEST_IMAGE
    - docker tag $CONTAINER_TEST_IMAGE $CONTAINER_RELEASE_TAGGED_IMAGE
    - docker push $CONTAINER_RELEASE_TAGGED_IMAGE

